//+---------------------------------------------+
//|                        FTW_VirtualORder.mq4 |
//|     Copyright  2007,PRIMAjaya, mod: dimicr |
//|   PRIMAjaya  http://primaforex.blogspot.com |
//|            dimicr  http://www.signalsbg.com |
//+---------------------------------------------+
/*
from waddah attar EA strategy for Automated Trading Championship 2007.
-------------------------------------------------------------------------------------------------
The idea of this EA is open buy and sell order at the same time (default is 22:00 GMT).
If one of them hit the StopLoss, then the expert open more order according to win order
So I change the name to FTW (Follow The Winner).
-------------------------------------------------------------------------------------------------
After watch the waddah EA performance, there is something different between waddah EA and this EA
because waddah EA sometimes open double buy or double sell.
But anyway.. I still believe with this expert
-------------------------------------------------------------------------------------------------
Virtual orders by dimicr... Thank's! 
At the same time we open buy and sell orders but in virtual mode, when one of them hit the SL, 
we open double orders in real according to win order
-------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------
All the setting for FTW EA is here, if you find profitable setting for any other pair please
feel free to fill it here:

Waddah setting:
Pair = GBPJPY;
Target = 330;
StopLoss = 200;
OpenHours = 22;

PRIMAjaya setting
Pair = EURUSD
Target = 100;
StopLoss = 65;
OpenHours = 22;

dimicr setting
Pair = GBPJPY
Target = 490;
StopLoss = 170;
OpenHours = 1; 

*/

//karena penasaran dan waddah nggak mau share codenya, jadi coding sendiri...^_^ 

#property copyright "Copyright  2007,PRIMAjaya, mod:dimicr"
#property link      "http://www.signalsbg.com"

extern string  Pair="GBPJPY";
extern int     Target=490;
extern int     StopLoss=170;
extern int     OpenHours=1;//default time is 22:00 GMT, your broker time is GMT-2 than OpenHours should be 20
extern double  LotsTrade=1.0;

// Virtual Order properties
static int		virtTicket	 = 0;
int		virtBuyTicket		 = 0;
int		virtSellTicket		 = 0;	 
double	virtBuyOpenPrice	 = 0.0; 
double	virtSellOpenPrice	 = 0.0;
double	virtBuyStopLoss	 = 0.0;
double	virtSellStopLoss	 = 0.0; 
double	virtBuyTakeProfit	 = 0.0;
double	virtSellTakeProfit = 0.0; 

#define slip 1
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   run();
   return(0);
  }
//+------------------------------------------------------------------+

  /////////////////////
 //untuk market info//
/////////////////////  
double x (string info)
{  RefreshRates();
   if(info=="a")  return (MarketInfo(Pair,MODE_ASK));
   if(info=="b")  return (MarketInfo(Pair,MODE_BID));
   if(info=="p")  return (MarketInfo(Pair,MODE_POINT));
}   
int y(string info)
{  if(info=="d")  return (MarketInfo(Pair,MODE_DIGITS));
   if(info=="sl")  return (MarketInfo(Pair,MODE_STOPLEVEL));
}

  ////////////////////
 //untuk open order//
////////////////////
void openorder(string simbol, int trade, double lotsize, double price, double sl, double tp, int ajaib) 
{  int tiket;                   
   tiket=OrderSend(simbol,trade,lotsize,price,slip,sl,tp,"--FTW--",ajaib,0,Black);                              
      if(tiket>0)
      {  if(OrderSelect(tiket,SELECT_BY_TICKET,MODE_TRADES)) OrderPrint(); 
      }
         else Print("order open error because of: ",GetLastError());        
}
  ////////////
 //jalankan//
////////////
void run()
{  
      
   bool buysell=false,openmore=false;
   if(virtTicket<1 && Hour()==OpenHours && Minute()<=5) buysell=true; // open buy and sell at OpenHours, and I think 5 minutes is more than enough for order process
   
   if(buysell)
   {  
      virtBuyOrderSend(x("a"),x("a")-StopLoss*x("p"),x("a")+Target*x("p"));
      virtSellOrderSend(x("b"),x("b")+StopLoss*x("p"),x("b")-Target*x("p"));        
   }
   
   ManageVirtualOrders();
   
   virtTicket = virtSellTicket + virtBuyTicket;
   
   if(virtTicket==1) openmore=true; // open more trades, when SL hit..
   if(openmore && ScanOrders()<2)
   {    
         {  if(virtBuyTicket == 1) 
            {  openorder(Pair,OP_BUY,LotsTrade,x("a"),virtBuyStopLoss,virtBuyTakeProfit,56789);
            }
            else
            {  openorder(Pair,OP_SELL,LotsTrade,x("b"),virtSellStopLoss,virtSellTakeProfit,98765);              
            }
            return(0);   
         }
   
   }                          
}


int ScanOrders()
{
   int   total = OrdersTotal();
   int   orders = 0;
   for(int i = 0; i < total; i++)
   {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL && OrderSymbol()==Pair) orders += 1;
   }

   return(orders);
}


void ManageVirtualOrders()
{
     
	  if(virtTicket > 0)
	    {
		     //---- Virtual BUY
		     if(virtBuyTicket == 1)
		       {
			        //---- if Virtual Buy Hit  SL then close it
			        if(virtBuyStopLoss > 0.0 && NormalizeDouble(virtBuyStopLoss - x("b"), y("d")) >= 0.0)
				           virtBuyOrderClose();
			         //---- if Virtual Buy Hit TP then close it
			        if(virtBuyTakeProfit > 0.0 && NormalizeDouble(x("b") - virtBuyTakeProfit, y("d")) >= 0.0)
				           virtBuyOrderClose();
		       }
		     //---- Virtual  SELL
		     if(virtSellTicket == 1)
		       {
			        //---- if Virtual Sell Hit SL then close it
			        if(virtSellStopLoss > 0.0 && NormalizeDouble(x("a") - virtSellStopLoss, y("d")) >= 0.0)
				           virtSellOrderClose();
			        ///---- if Virtual Sell Hit TP then close it
			        if(virtSellTakeProfit > 0.0 && NormalizeDouble(virtSellTakeProfit - x("a"), y("d")) >= 0.0)
				           virtSellOrderClose();     
		       }
	    }
	    
}


void virtBuyOrderSend(double openprice, double stoploss, double takeprofit)
  {
   virtBuyTicket = 1;
   virtBuyOpenPrice = openprice;
   virtBuyStopLoss = stoploss;
   virtBuyTakeProfit = takeprofit;
   virtTicket = virtSellTicket + virtBuyTicket;
   
   Print("Open Virtual Buy at :"+openprice+" SL :"+stoploss+" TP :"+takeprofit+"");
   
  }


void virtSellOrderSend(double openprice, double stoploss, double takeprofit)
  {
   virtSellTicket = 1;
   virtSellOpenPrice = openprice;
   virtSellStopLoss = stoploss;
   virtSellTakeProfit = takeprofit;
   virtTicket = virtSellTicket + virtBuyTicket ;
   
   Print("Open Virtual Sell at :"+openprice+" SL :"+stoploss+" TP :"+takeprofit+"");
  }
  

void virtBuyOrderClose()
  {
	  virtBuyTicket = 0;
	  virtBuyOpenPrice = 0.0;
     virtBuyStopLoss = 0.0;
     virtBuyTakeProfit = 0.0;
     virtTicket -= 1;
  }
  
void virtSellOrderClose()
  {    
	  virtSellTicket = 0;
	  virtSellOpenPrice = 0.0;
     virtSellStopLoss = 0.0;
     virtSellTakeProfit = 0.0;
     virtTicket -= 1;
  }